unit U_berge;

interface

uses Wintypes { TPoint }, ExtCtrls { fr TPaintbox };

type TGebirge = class
       Paintbox: TPaintbox;
       Punkte: array[1..255,1..255] of byte;
       constructor create(PB: TPaintbox);
       procedure Anzeigen;
     end;
implementation

constructor TGebirge.create(PB: TPaintbox);
{ Das Gebirge wird wie folgt erstellt. Zuerst werden zwei Kegel mit der Hhe 80 aufgestellt (k<3)
  danach wird das Gebirge noch 498 mal um einen Zufallspunkt kegelfrmig um die Hhe 8 angehoben }
var k, x, y: integer;
    p1: TPoint;
    r: integer;
    h: byte;
begin
  Paintbox:= PB;
  for x:= 1 to 255 do for y:= 1 to 255 do Punkte[x,y]:= 0;   { Initialisierung als Ebene }
  for k:= 1 to 500                                           { insgesamt 500 Kegel aufstellen }
  do begin
       p1.x:= random(256)+1;                                 { Koordingaten der Kegelspitze festlegen }
       p1.y:= random(256)+1;
       r:= random(100)+1;                                    { zuflligen Grundflchen-Radius festlegen }
       for x:= p1.x-r to p1.x+r
       do for y:= p1.y-r to p1.y+r                           { Fr alle Punkte in der Grundflche }
          do begin
               if (x>=1) and (x<=255) and (y>=1) and (y<=255) and (sqr(1.0*p1.x-x)+sqr(1.0*p1.y-y)<=sqr(1.0*r))
               then begin
                      if k<3
                      then h:=trunc((r-sqrt(sqr(1.0*p1.x-x)+sqr(1.0*p1.y-y)))/r*80)  { hebe die ersten beiden Kegel um 80 an }
                      else h:= trunc((r-sqrt(sqr(1.0*p1.x-x)+sqr(1.0*p1.y-y)))/r*8); { hebe alle anderen Kegel um 8 an. }
                      if Punkte[x,y]<=255-h then Punkte[x,y]:= Punkte[x,y]+h         { Hchstens bis Hhe 255 anheben }
                                            else Punkte[x,y]:= 255;
                    end;
             end;
     end;
end;

procedure TGebirge.Anzeigen;
var x, y: integer;
begin
  for x:= 1 to 255                                {RGB-Umrechnung}
  do for y:= 1 to 255                             {r+256*g+256*b}  { Fr alle Gebirgspunkte }
     do Paintbox.Canvas.Pixels[x,y]:= Punkte[x,y]*(1+256+256*256);  { Gib Pixel in Graustufe aus. Wei=255, Schwarz=0 }
end;

end.
